/**
 * @file DoubleBuffering.cpp
 * @brief EBhẼ_uobt@OsNXłB
 * @author Shinji Watanabe
 * @version 1.0
 * @date Jan.06.2008
 */

#include "DoubleBuffering.h"

/**
 * CDoubleBuffering::CDoubleBuffering
 * @brief RXgN^
 */
CDoubleBuffering::CDoubleBuffering(){
	m_MainSurface = NULL;
	m_MainSurfaceOld = NULL;
	m_MainSurfaceDC = NULL;
	m_nWidth = 0;
	m_nHeight = 0;
	m_bRendered = false;
}

/**
 * CDoubleBuffering::~CDoubleBuffering
 * @brief fXgN^
 */
CDoubleBuffering::~CDoubleBuffering(){
	/*T[tBX֘A*/
	if (m_MainSurface){
		SelectObject(m_MainSurfaceDC,m_MainSurfaceOld);
		DeleteObject(m_MainSurface);
		m_MainSurface = NULL;
	}
	if (m_MainSurfaceDC){
		DeleteDC(m_MainSurfaceDC);
	}
}

/**
 * CDoubleBuffering::SetRendInfo
 * @brief `ۑ
 */
void CDoubleBuffering::SetRendInfo(CEthicLine *pFirstVisible){
	m_bRendered = true;
	m_cRenderedFirstVisible = *pFirstVisible;
}

/**
 * CDoubleBuffering::ChangeSize
 * @brief TCY̕ύX
 */
bool CDoubleBuffering::ChangeSize(HWND hWnd,int nWidth,int nHeight)
{
	// ܂łƓTCYȂmۂȂ
	if (m_nWidth == nWidth && m_nHeight == nHeight)
	{
		return true;
	}

	HDC hDC = ::GetDC(hWnd);
	//FOOTY2_PRINTF( L"GetDC\n" );
	if ( !hDC )
	{
		FOOTY2_PRINTF( L"But failed...\n" );
	}

	// ݊foCXReLXg邩ǂ
	if (!m_MainSurfaceDC)
	{
		m_MainSurfaceDC = CreateCompatibleDC(hDC);
		if (!m_MainSurfaceDC)
		{
			FOOTY2_PRINTF( L"failed to create compatibleDC\n" );
			ReleaseDC(hWnd,hDC);
			FOOTY2_PRINTF( L"ReleaseDC\n" );
			return false;
		}
	}
	
	// _uobt@OΔj
	if (m_MainSurface)
	{
		DeleteObject(m_MainSurface);
		m_MainSurface = NULL;
	}
	
	// Vobt@𐶐
	m_MainSurface=CreateCompatibleBitmap(hDC,nWidth,nHeight);		// Ɋ֘Arbg}bv쐬
	if (!m_MainSurface)
	{
		ReleaseDC( hWnd, hDC );
		FOOTY2_PRINTF( L"ReleaseDC\n" );
		return false;
	}
	if (!m_MainSurfaceOld)
	{
		m_MainSurfaceOld = (HBITMAP)SelectObject(m_MainSurfaceDC,m_MainSurface);	
	}
	else
	{
		SelectObject(m_MainSurfaceDC,m_MainSurface);
	}
	if (m_nWidth > nWidth || m_nHeight > nHeight)					// ꂽƂ
	{
		BitBlt(m_MainSurfaceDC,0,0,nWidth,nHeight,hDC,0,0,SRCCOPY);	// Ro`uDCɃRs[
	}
	ReleaseDC(hWnd,hDC);											// foCXReLXgJ
	//FOOTY2_PRINTF( L"ReleaseDC\n" );

	// oϐɊi[
	m_nHeight = nHeight;
	m_nWidth = nWidth;

	// x`悳ĂȂԂɂ
	m_bRendered = false;
	return true;
}

/*[EOF]*/
